package edu.kit.ipd.descartes.adaptation.evaluation;

import edu.kit.ipd.descartes.adaptation.evaluation.weightingfunction.WeightedSumCalculator;
import edu.kit.ipd.descartes.mm.adaptation.WeightedTactic;
import edu.kit.ipd.descartes.mm.adaptation.WeightingFunction;

/**
 * Evaluates a given {@link WeightedTactic} using the weighted tactic's {@link WeightingFunction}.
 * 
 * @author nhuber
 * 
 */
public class WeightingFunctionEvaluator implements IEvaluator {

    private WeightedSumCalculator calculator = null;

    public WeightingFunctionEvaluator() {
        calculator = new WeightedSumCalculator();
    }
    
    /*
     * (non-Javadoc)
     * 
     * @see edu.kit.ipd.descartes.adaptation.evaluation.IEvaluator#evaluate()
     */
    @Override
    public void evaluate(WeightedTactic tactic) {
        WeightingFunction f = tactic.getParentStrategy().getWeightingFunction();
        calculator.setWeightingFunction(f);
        calculator.updateWeight(tactic);
    }
}
