package edu.kit.ipd.descartes.adaptation.model.dmm.util;

import java.util.List;

import edu.kit.ipd.descartes.adaptation.evaluation.weightingfunction.WeightingFunctionHelper;
import edu.kit.ipd.descartes.mm.adaptation.Event;
import edu.kit.ipd.descartes.mm.adaptation.RelationalOperator;
import edu.kit.ipd.descartes.mm.adaptation.Specification;
import edu.kit.ipd.descartes.perfdatarepo.MetricType;
import edu.kit.ipd.descartes.perfdatarepo.Result;

public class ObjectivesHelper {

    public static boolean compare(double left, double right, RelationalOperator operator) {
        switch (operator) {
        case EQUAL:
            return left == right;
        case NOT_EQUAL:
            return left != right;
        case LESS:
            return left < right;
        case LESS_EQUAL:
            return left <= right;
        case GREATER:
            return left > right;
        case GREATER_EQUAL:
            return left >= right;
        default:
            return false;
        }
    }

    public static boolean isProblemSolved(Event event, Result result) {
        List<Specification> specs = event.getTriggers().getObjective().getSpecifications();
        for (Specification specification : specs) {
            MetricType m = specification.getMetricType();
            Double actualValue = WeightingFunctionHelper.getValueForMetricType(m, result);
            Double threshold = specification.getValue();
            if (!ObjectivesHelper.compare(actualValue, threshold, specification.getRelationalOperator()))
                return false;

        }
        return true;
    }

}
