package edu.kit.ipd.descartes.adaptation.model.perfdatarepo;

import org.apache.log4j.Logger;
import org.eclipse.emf.common.util.URI;

import edu.kit.ipd.descartes.perfdatarepo.Impact;
import edu.kit.ipd.descartes.perfdatarepo.PerformanceDataRepository;
import edu.kit.ipd.descartes.perfdatarepo.Result;

public class PerformanceDataRepositoryHandler implements IPerformanceDataRepositoryHandler {
    
    private static Logger logger = Logger.getLogger(PerformanceDataRepositoryHandler.class); 
    
    private PerformanceDataRepository repository = null;
    private PerformanceDataRepositoryModelLoader modelLoader = null;
    
    public PerformanceDataRepositoryHandler() {
        modelLoader = new PerformanceDataRepositoryModelLoader();
        logger.debug("PerformanceDataRepositoryHandler instantiated.");
    }
    
    public void load(String fileUri) {
        repository = modelLoader.load(URI.createFileURI(fileUri));
    }

    @Override
    public Impact getLatestImpact() {
        return PerfDataRepoHelper.getLatestImpact(repository);
    }

    @Override
    public Impact getImpactAt(int position) {
        return PerfDataRepoHelper.getImpactAt(repository, position);
    }

    @Override
    public Result getCurrentSystemState() {
        // TODO Auto-generated method stub
        return null;
    }

}
